<?php

include '../../core.php';

checkAuth($raUrl);

cabecera (2);

$command = $_POST ["csr_command"];
$errorCode = "a0";

switch ( $command ) {

   default:
      // Nos traemos el numero copa, el identificador y la fecha de las 
      // solicitudes y de las revocaciones pendientes de ser enviadas a la CA
      $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaId=$raNum*)(|(pkirisStatus=approved)(pkirisStatus=revoke)))";
         
      echo "<h1 class='title'>Solicitudes de certificados y/o de revocaci&oacute;n de certificados pendientes de ser enviados a la CA</h1>\n";
      
      $justthese = array ("pkirisid","pkiriscopaid","pkirisdate", "pkirisstatus");
      $result = ldap_get_info($ldapVar['base'],$filter,$justthese);
      if ( !$result )
         $errorCode = "a4b1c2d1e1";
      else if ($result["count"] == 0) 
         echo "<p>No hay peticiones Nuevas</p>\n";      
      else {
         echo "<table border='0' cellpadding='0' cellspacing='0'>
         <tr><td class='header'>C&oacute;digo de Solicitud</td><td class='header'>Identificador</td><td class='header'>Fecha</td><td class='header'>Estado</td></tr>\n";
         
         for($i = 0; $i < $result['count']; $i++) {
           
            $copa = $result[$i]["pkiriscopaid"][0];
            $id = $result[$i]["pkirisid"][0];
            $anio = substr($result[$i]["pkirisdate"][0], 0, 4);
            $mes = substr($result[$i]["pkirisdate"][0], 4, 2);
            $dia = substr($result[$i]["pkirisdate"][0], 6, 2);
            $hora = substr($result[$i]["pkirisdate"][0], 8, 2);
            $minuto = substr($result[$i]["pkirisdate"][0], 10, 2);
            $segundo = substr($result[$i]["pkirisdate"][0], 12, 2);
            $fecha = $dia."/".$mes."/".$anio." - ".$hora.":".$minuto.":".$segundo;
	    $status = $result[$i]["pkirisstatus"][0];

            echo "<form method='post' action='csr_manage_export.php' enctype='multipart/form-data' name='manageExport_form'>
            <input type='hidden' name='copa' value='$copa' />
            <tr>";
            if ($i%2==0) {
               echo "<td class='even'><input class='button2' type='submit' value=$copa></td>
                     <td class='even'> $id </td>
                     <td class='even'> $fecha </td>
                     <td class='even'> $status </td>";
            }
            else {
               echo "<td class='odd'><input class='button2' type='submit' value=$copa></td>
                     <td class='odd'> $id </td>
                     <td class='odd'> $fecha </td>
                     <td class='odd'> $status </td>";
            }

            // Guardamos los codigos copa de todas las solicitudes en un array
            $copasArray[$i] = $copa; 
         }
         echo "</tr>
             </form>
           </table>
         <br/>
         <form method='post' action='csr_export.php?sessionID=$sessionID' enctype='multipart/form-data' name='csr_makeXml'>
           <input type='hidden' name='cantId' value='$i'>
           <input type='hidden' name='csr_command' value='make_xml'>";
           for ($j = 0; $j < $i; $j++){
              echo "<input type='hidden' name='pkiId$j' value='$copasArray[$j]'>";
           }
           echo "<input class='button' type='submit' value='Enviar a la CA' />
         </form>\n";
      }
   
   break;

   case "make_xml": //Crea la solicitud para exportar a la CA o a la RA en xml
      $cant = $_POST['cantId'];

      echo "<h1 class='title'>Exportaci&oacute;n de las solicitudes a la CA</h1>
            <h3> Hay $cant solicitudes que se van a enviar a la CA</h3>\n";
      
      // En primer lugar generamos el fichero XML que servira para enviar los
      // datos a la CA. Necesitaremos un array con los codigos copa de todas
      // las solicitudes que se van a exportar
      $copasArray = array ();
      for ($i = 0; $i < $cant; $i++) {
         $copa = $_POST["pkiId$i"];
         array_push( $copasArray, $copa);
	 $status = getStatus($copa);
         if ( !$status )
            $errorCode = "a4b1c2d2e2";
         else if ( $status == "revoke") {
	    // Las revocaciones pendientes las exportaremos de una en una,
	    $xmlString = createXML ( $copasArray );
            if ( !$xmlString )
               $errorCode = "a4b1c2d2e1";
	    // por lo que una vez generado el XML, la sacamos del array
	    array_pop( $copasArray );	    
	 }
      }
	  
      if ( $errorCode == "a0" ) { 
         // Generamos el fichero y guardamos el codigo XML en una variable, 
         // si al menos hay una solicitud/certificado a exportar
         if ( $copasArray != null ) { 
            $xmlString = createXML ( $copasArray );	 
            if ( !$xmlString ) 
               $errorCode = "a4b1c2d2e1";
            else {	
               // Si no ha habido errores, enviamos un mail al administrador 
               $envioMail = mail($ldapVar['adminCaMail'], "CSR Aprobada", "Se ha generado un archivo de exportaci&oacute;n con $cant solicitudes para ser enviadas a la CA\n\n\n$xmlString");
               $pkiLog['status'] = $status;
               $pkiLog['eee'] = $copa;
               $pkiLog['user'] = "RA-Admin";
               $pkiLog['error'] = $errorCode;
               writeLog ($pkiLog);
               echo "\n<p>La exportaci&oacute;n se ha efectuado con &eacute;xito.</p>\n";
            }
         }
      }

      break;
}

// Si se ha producido algun error, llamamos a la funcion encargada de
// tratarlos
if ( $errorCode != "a0" ) {
   echo "<h3>Error en la exportaci&oacute;n.</h3>";

   $pkiLog['status'] = $status;
   $pkiLog['eee'] = $copa;
   $pkiLog['user'] = "RA-Admin";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
}

pie ();
	
?>
